/*
DIOWave Visual Storage.
Copyright (C) 2002, Takaya Sakusabe

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

typedef struct {
	unsigned long m_allocated_size;
	char m_buf[0x10000];
} codec_mem_t;

#ifdef __cplusplus
extern "C" {
#endif
	int codec_write_client(void* ecb, void* buf, size_t len);
	void codec_log_message(const char* message);

	void* codec_mem_alloc(codec_mem_t* cm, size_t size);
	void codec_mem_free(codec_mem_t* cm, void* ptr);

#ifdef __cplusplus
}
#endif

typedef void (*f_decode_input_func)(void* input_ctx, int command, const void** next_input_byte, unsigned int* bytes_in_buffer, int arg);

#ifdef __cplusplus
#define expCODEC_msg_size 256
class expCODEC {
public:
	char msg[expCODEC_msg_size];

	expCODEC(const char* message);
};
#endif

