/*
DIOWave Visual Storage.
Copyright (C) 2002, Takaya Sakusabe

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//
// Real Time Logging System
//
#define _RTLOG_IMPL_
#include "rtlog.h"

#define rlSocketLog	0x01FEFFFF
#define rlDULFSMLog	0x02FEFFFF
#define rlCondLog	0x03FEFFFF

int rtlog_on = 0;
rlLogWriter rtlog_writer = (rlLogWriter)NULL;

void rtlog_socket(DWORD flag, SOCKET sock, DWORD requestedSize, DWORD resultSize)
{
	if (rtlog_writer == NULL)
		return;

	if (flag == rlSocketAccept) {

		SOCKADDR_IN* localAddr = (SOCKADDR_IN*)requestedSize;
		SOCKADDR_IN* remoteAddr = (SOCKADDR_IN*)resultSize;

		DWORD data[5];
		data[0] = rlSocketLog;
		data[1] = flag;
		data[2] = (DWORD)sock;
		data[3] = localAddr->sin_port;
		data[4] = remoteAddr->sin_addr.S_un.S_addr;

		rtlog_writer(&data, sizeof(data));
			
	} else if (flag == rlSocketRead || flag == rlSocketWrite) {

		DWORD data[5];
		data[0] = rlSocketLog;
		data[1] = flag;
		data[2] = (DWORD)sock;
		data[3] = requestedSize;
		data[4] = resultSize;

		rtlog_writer(&data, sizeof(data));

	} else if (flag == rlSocketClose) {

		DWORD data[3];
		data[0] = rlSocketLog;
		data[1] = flag;
		data[2] = (DWORD)sock;

		rtlog_writer(&data, sizeof(data));
	}

}
void rtlog_dulfsm(SOCKET sock, DWORD event, DWORD state)
{
	if (rtlog_writer == NULL)
		return;

	DWORD data[4];
	data[0] = rlDULFSMLog;
	data[1] = (DWORD)sock;
	data[2] = event;
	data[3] = state;

	rtlog_writer(&data, sizeof(data));

}
void rtlog_cond(CONDITION cond, const char* str)
{
	if (rtlog_writer == NULL)
		return;

	if (CTN_SUCCESS(cond) || CTN_INFORM(cond))
		return;

	int str_len = strlen(str) + 1;
	int data_len = (2 + (str_len + 3) / 4) * sizeof(DWORD);
	DWORD* data = (DWORD*)_alloca(data_len);
	data[0] = rlCondLog;
	data[1] = cond;
	CopyMemory(&data[2], str, str_len);
	
	rtlog_writer(data, data_len);
}

