/*
DIOWave Visual Storage.
Copyright (C) 2002, Takaya Sakusabe

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/*
 *
 */
typedef struct tagDCMDICT {
    const DCM_TAG tag;
    const DCM_VALUEREPRESENTATION representation;
    const char* const englishDescription;
} DCMDICT;

typedef struct tagGROUPPTR {
    const unsigned int group;
    const unsigned int entries;
    const DCMDICT* const dict;
} GROUPPTR;

typedef struct tagGROUP_DESCRIPTION {
    const unsigned int group;
    const char* const description;
} GROUP_DESCRIPTION;

/*
 *
 */
 
#ifdef __cplusplus
extern "C" {
#endif
	__declspec(dllexport) const DCMDICT* DcmLookupDict(const DCM_TAG tag, const GROUPPTR** gdpp, const DCMDICT** cdpp);
	__declspec(dllexport) const char* DcmGetVRStr(const int vr);
	__declspec(dllexport) int DcmGetVRCode(const char* const vr);
#ifdef __cplusplus
}
//======================================
//
//======================================
class CDcmDict {
	const GROUPPTR* m_gdp;
	const DCMDICT* m_cdp;
public:
	CDcmDict()
		: m_cdp(NULL), m_gdp(NULL) {}
		
	const DCMDICT* Lookup(const DCM_TAG tag) {
		return DcmLookupDict(tag, &m_gdp, &m_cdp);
	}

	static bool isString(DCM_VALUEREPRESENTATION vr) {
		switch (vr) {
		case DCM_AE:
		case DCM_AS:
		case DCM_CS:
		case DCM_DA:
		case DCM_DS:
		case DCM_DT:
		case DCM_IS:
		case DCM_LO:
		case DCM_LT:
		case DCM_PN:
		case DCM_SH:
		case DCM_ST:
		case DCM_TM:
		case DCM_UI:
		case DCM_UT:
			return true;
		default:
			return false;
		}
	}
};
#endif
