
/* borrowed from unzpriv.h
   typedef uch   local_byte_hdr[ LREC_SIZE ];
#      define L_VERSION_NEEDED_TO_EXTRACT_0     0
#      define L_VERSION_NEEDED_TO_EXTRACT_1     1
#      define L_GENERAL_PURPOSE_BIT_FLAG        2
#      define L_COMPRESSION_METHOD              4
#      define L_LAST_MOD_DOS_DATETIME           6
#      define L_CRC32                           10
#      define L_COMPRESSED_SIZE                 14
#      define L_UNCOMPRESSED_SIZE               18
#      define L_FILENAME_LENGTH                 22
#      define L_EXTRA_FIELD_LENGTH              24
*/

#define ZIP_LH_SIG "PK\x03\x04"
#define ZIP_LH_COMPRESSION_METHOD (4+4)
#define ZIP_LH_COMPRESSED_SIZE (14+4)
#define ZIP_LH_UNCOMPRESSED_SIZE (18+4)
#define ZIP_LH_FILENAME_LENGTH (22+4)
#define ZIP_LH_EXTRA_FIELD_LENGTH (24+4)
#define ZIP_LH_SIZE (26+4)

/* borrowed from unzpriv.h
   typedef uch   cdir_byte_hdr[ CREC_SIZE ];
#      define C_VERSION_MADE_BY_0               0
#      define C_VERSION_MADE_BY_1               1
#      define C_VERSION_NEEDED_TO_EXTRACT_0     2
#      define C_VERSION_NEEDED_TO_EXTRACT_1     3
#      define C_GENERAL_PURPOSE_BIT_FLAG        4
#      define C_COMPRESSION_METHOD              6
#      define C_LAST_MOD_DOS_DATETIME           8
#      define C_CRC32                           12
#      define C_COMPRESSED_SIZE                 16
#      define C_UNCOMPRESSED_SIZE               20
#      define C_FILENAME_LENGTH                 24
#      define C_EXTRA_FIELD_LENGTH              26
#      define C_FILE_COMMENT_LENGTH             28
#      define C_DISK_NUMBER_START               30
#      define C_INTERNAL_FILE_ATTRIBUTES        32
#      define C_EXTERNAL_FILE_ATTRIBUTES        34
#      define C_RELATIVE_OFFSET_LOCAL_HEADER    38
*/

#define ZIP_CD_SIG "PK\x01\x02"
#define ZIP_CD_FILENAME_LENGTH (24+4)
#define ZIP_CD_EXTRA_FIELD_LENGTH (26+4)
#define ZIP_CD_FILE_COMMENT_LENGTH (28+4)
#define ZIP_CD_SIZE (42+4)

/* borrowed from unzpriv.h
   typedef uch   ec_byte_rec[ ECREC_SIZE+4 ];
#      define SIGNATURE                         0 
#      define NUMBER_THIS_DISK                  4
#      define NUM_DISK_WITH_START_CENTRAL_DIR   6
#      define NUM_ENTRIES_CENTRL_DIR_THS_DISK   8
#      define TOTAL_ENTRIES_CENTRAL_DIR         10
#      define SIZE_CENTRAL_DIRECTORY            12
#      define OFFSET_START_CENTRAL_DIRECTORY    16
#      define ZIPFILE_COMMENT_LENGTH            20

*/

#define ZIP_ED_SIG "PK\x05\x06"
#define ZIP_ED_ZIPFILE_COMMENT_LENGTH 20
#define ZIP_ED_SIZE 22

inline unsigned short zip_makeword(const char* b)
{
    /* borrowed from unzpriv.h
     * Convert Intel style 'short' integer to non-Intel non-16-bit
     * host format.  This routine also takes care of byte-ordering.
     */
    return ((unsigned short)((unsigned char*)b)[1] << 8) | (unsigned short)((unsigned char*)b)[0];
}

inline unsigned long zip_makelong(const char* b)
{
    /* borrowed from unzpriv.h
     * Convert intel style 'long' variable to non-Intel non-16-bit
     * host format.  This routine also takes care of byte-ordering.
     */
    return (((unsigned long)((unsigned char*)b)[3]) << 24)
        + (((unsigned long)((unsigned char*)b)[2]) << 16)
        + (((unsigned long)((unsigned char*)b)[1]) << 8)
        + ((unsigned long)((unsigned char*)b)[0]);
}
