/*
DIOWave Visual Storage.
Copyright (C) 2002, Takaya Sakusabe

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <math.h>

main()
{
	FILE* fp = fopen("hypotTable.c", "w");

	fprintf(fp, "float hypotTable[256 * 256] = {\n");

	for (int y = 0; y < 256; y++) {
		float y2 = y / 256.0;
		y2 *= y2;
		for (int x = 0; x < 256; x++) {
			float x2 = x / 256.0;
			x2 *= x2;
			float rate = 1.0 - sqrt(x2 + y2);
			if (rate < 0.0)
				rate = 0.0;
			fprintf(fp, "%e, ", rate);
			if ((x & 3) == 3)
				fprintf(fp, "\n");
		}
	}

	fprintf(fp, "};\n");

	fclose(fp);
}
