#ifndef _5526E321_648E_465B_9844_202CF3A4E595_
#define _5526E321_648E_465B_9844_202CF3A4E595_

/*
DIOWave Visual Storage.
Copyright (C) 2002, Takaya Sakusabe

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "DataElementCache.h"
#include "InstanceCache.h"

class CStudyCache {
	wchar_t* m_studyDir;
	int m_studyDirLen;
	const bool m_commit_immediately;

	CDataElementCacheFile m_dc;
	CInstanceCacheFile m_ic;

	HRESULT open(const wchar_t* studyDir);
	HRESULT close();

public:
	CStudyCache(bool commit_immediately = false)
		: m_dc(), m_ic(), m_studyDir(NULL), m_studyDirLen(0), m_commit_immediately(commit_immediately)
	{
	}
	~CStudyCache();

	HRESULT append(const wchar_t* studyDir, const wchar_t* imageLoc, const char* scannedElements, size_t scannedElementsSize);
};

#endif
