#ifndef DIO_STORAGE_IS_IN
#define DIO_STORAGE_IS_IN 1

/*
DIOWave Visual Storage.
Copyright (C) 2002, Takaya Sakusabe

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "dw-config.h"

#ifdef __cplusplus
extern "C" {
#endif

/*
//----------------------------------------------------------------------------------------
// Storage Parmater
//----------------------------------------------------------------------------------------
*/
#define	DIO_STORAGE_AE_TITLE "DIO_STORAGE"
#define DIO_STORAGE_SERVICENAME "DIO_STORAGE"
#define DIO_STORAGE_SERVICDISPLAYENAME "DIOWave DICOM SCP"

#define kDUL_RelaseDelay (5*1000)

#define kStorageStatQueueSize 16

/*
//----------------------------------------------------------------------------------------
// Storage Parmater
//----------------------------------------------------------------------------------------
*/
struct tStorageParam {

	/* */
	HRESULT m_hr;

	/* */
	const tDWConfig* pConfig;
	const tSCPprm* pSCPprm;

	/* */
	DWORD dwThreadId;
	HANDLE hThread;

	/* */
	tWaitSocketParam wsp;

	/* */
	char* last_study_loc;
	BSTR check_sql;

	/* */
	struct assoc_info_t {
		char callingAPTitle[32];
		unsigned long commandCount;
		unsigned long requestCount;
		unsigned long long recievedBytes;
		unsigned long storedFiles;
		unsigned long long storedBytes;
		unsigned long overwriteFiles;

		void reset()
		{
			commandCount = 0;
			requestCount = 0;
			recievedBytes = 0;
			storedFiles = 0;
			storedBytes = 0;
			overwriteFiles = 0;
			*callingAPTitle = '\0';
		}
		
	} assoc;

};

/*
//----------------------------------------------------------------------------------------
// StorageLog
//----------------------------------------------------------------------------------------
*/
class StorageLog : public CConsoleLog {
public:
	static void print_assoc_open_info(const tStorageParam* sp);
	static void print_assoc_close_info(const tStorageParam* sp);
	static void print_remove_study_info(const tStorageParam* sp, const wchar_t* path, unsigned long bytesDeleted);
	static void print_insert_study_info(const tStorageParam* sp, const char* path);

	static StorageLog* self;
};


/*
//----------------------------------------------------------------------------------------
// Function Prototypes
//----------------------------------------------------------------------------------------
*/

/* storage-service.cpp */
void InitVolumeMangement(void);
void FinVolumeManagement(void);
void InitRTLog(void);
void FinRTLog(void);
DWORD WINAPI StorageProviderThread(LPVOID);

extern tDWConfig* gDWConfig;

#ifdef __cplusplus
}
#endif

#endif
