#ifndef _90026AB6_A6EA_4D1F_AF99_3D7AEA8F848C_
#define _90026AB6_A6EA_4D1F_AF99_3D7AEA8F848C_

/*
DIOWave Visual Storage.
Copyright (C) 2002, Takaya Sakusabe

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//======================================================================
//
//
//
//======================================================================
class RequestFileWatcher {
public:
	SimpleErrorInfo m_ei;

	HANDLE m_hStopEvent;

	HANDLE m_hThread;
	DWORD m_dwThreadId;

	//
	// config params
	//
	struct config_t {
		wchar_t* m_watchDirectory;
		DWORD m_timeOut;
		DWORD m_storeLimitBytes;
		DWORD m_storeLimitFiles;
		char* m_host;
		unsigned short m_port;
		char* m_scu_title;
		char* m_scp_title;

		static config_t defaultConfig;

		static HRESULT New(IXMLDOMNode* configNode, config_t** pConfig, SimpleErrorInfo& ei);
	};

	config_t* m_config;

	HRESULT Init(IXMLDOMNode* configNode)
	{
		return config_t::New(configNode, &m_config, m_ei);
	}

	HRESULT ScanRequestFiles(const wchar_t* watchDirectory, IXMLDOMDocument* dom, unsigned long& numFilesToStore) throw (SimpleErrorInfo);
	HRESULT SendFiles(DUL_NETWORKKEY* network, tWaitSocketParam& wsp, IXMLDOMDocument* dom) throw (SimpleErrorInfo);

	RequestFileWatcher()
	{
	}

	~RequestFileWatcher()
	{
	}

	static DWORD WINAPI ThreadProc(LPVOID lpParam);

	static HRESULT Main(bool consoleMode, HANDLE hStopEvent, const wchar_t* const configPath);

	HRESULT SingleShot(RequestFileWatcher::config_t* config, const wchar_t* const directory);

private:
	DWORD thread_proc(void);

	HRESULT scanRequestFiles(const wchar_t* watchDirectory, unsigned long& scannedRequestFileCount, unsigned long& numFilesToStore, unsigned long long& numBytesToStore, IXMLDOMDocument* dom) throw (SimpleErrorInfo);
	HRESULT readRequestFile(const wchar_t* reqFile, const WIN32_FIND_DATA& data, IXMLDOMDocument* dom, unsigned long& numFilesToStore, unsigned long long& numBytesToStore) throw (SimpleErrorInfo);
	HRESULT collect_files(IXMLDOMDocument* dom, IXMLDOMElement* reqFileElm, const wchar_t* directory, unsigned long& numFilesToStore, unsigned long long& numBytesToStore) throw (SimpleErrorInfo);
	HRESULT collect_files(IXMLDOMDocument* dom, const wchar_t* directory, IXMLDOMElement* fileList, unsigned long& numFilesToStore, unsigned long long& numBytesToStore) throw (SimpleErrorInfo);
	HRESULT collect_file(IXMLDOMDocument* dom, const wchar_t* file, const WIN32_FIND_DATA& data, IXMLDOMElement* fileList, unsigned long& numFilesToStore, unsigned long long& numBytesToStore) throw (SimpleErrorInfo);
};

#endif
