/*
DIOWave Visual Storage.
Copyright (C) 2002, Takaya Sakusabe

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "DcmDict.h"
#include "CDcmScanner.h"
#include "UtilClasses.h"

#include "RequestFileWatcher.h"

//----------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------
int main(int argc, const char** argv)
{
	if (argc != 6) {
		printf("Usage: SCU-TITLE SCP-TITLE HOST PORT DIRECTORY\n");
		return 1;
	}

	RequestFileWatcher::config_t config;
	CopyMemory(&config, &RequestFileWatcher::config_t::defaultConfig, sizeof(RequestFileWatcher::config_t));

	config.m_scu_title = const_cast<char*>(argv[1]);
	config.m_scp_title = const_cast<char*>(argv[2]);
	config.m_host = const_cast<char*>(argv[3]);
	config.m_port = atoi(argv[4]);

	const char* const directory = argv[5];
	TOWC(directory)

	DWORD fileAttr = GetFileAttributes(_directory_WC);
	if (fileAttr == 0xFFFFFFFF || ((fileAttr & FILE_ATTRIBUTE_DIRECTORY) == 0)) {
		printf("Error: %s not found or not directory\n", directory);
		return 1;
	}

	RequestFileWatcher rw;

	rw.SingleShot(&config, _directory_WC);
}

